/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64;

import ru.ispras.microtesk.model.api.ModelBuilder;
import ru.ispras.microtesk.model.mips64.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.mips64.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "mips64",
        MetaModelFactory.newMetaModel(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(R.INFO);
    addMode(FR.INFO);
    addMode(CPRGET.INFO);
    addMode(CPRSET.INFO);
    addMode(C0_R.INFO);
    addMode(CP2CPRGET.INFO);
    addMode(CP2CPRSET.INFO);
    addMode(C.INFO);
    addMode(FMT_FORMAT_S.INFO);
    addMode(FMT_FORMAT_D.INFO);
    addMode(FMT_FORMAT_W.INFO);
    addMode(FMT_FORMAT_L.INFO);
    addMode(FMT_FORMAT_PS.INFO);
    addMode(F_COND.INFO);
    addMode(UN_COND.INFO);
    addMode(EQ_COND.INFO);
    addMode(UEQ_COND.INFO);
    addMode(OLT_COND.INFO);
    addMode(ULT_COND.INFO);
    addMode(OLE_COND.INFO);
    addMode(ULE_COND.INFO);
    addMode(SF_COND.INFO);
    addMode(NGLE_COND.INFO);
    addMode(SEQ_COND.INFO);
    addMode(NGL_COND.INFO);
    addMode(LT_COND.INFO);
    addMode(NGE_COND.INFO);
    addMode(LE_COND.INFO);
    addMode(NGT_COND.INFO);

    addOperation(exception.INFO);
    addOperation(StoreFPR.INFO);
    addOperation(add_fmt.INFO);
    addOperation(abs_fmt.INFO);
    addOperation(div_fmt.INFO);
    addOperation(madd_fmt.INFO);
    addOperation(msub_fmt.INFO);
    addOperation(mul_fmt.INFO);
    addOperation(neg_fmt.INFO);
    addOperation(nmadd_fmt.INFO);
    addOperation(nmsub_fmt.INFO);
    addOperation(recip_fmt.INFO);
    addOperation(rsqrt_fmt.INFO);
    addOperation(sqrt_fmt.INFO);
    addOperation(sub_fmt.INFO);
    addOperation(C_cond.INFO);
    addOperation(C_cond2.INFO);
    addOperation(FPConditionCode.INFO);
    addOperation(bc1f.INFO);
    addOperation(mips64_load_fpu.INFO);
    addOperation(mips64_load_fpu_short.INFO);
    addOperation(ldc1.INFO);
    addOperation(ldxc1.INFO);
    addOperation(cfc1.INFO);
    addOperation(ctc1.INFO);
    addOperation(dmfc1.INFO);
    addOperation(dmtc1.INFO);
    addOperation(mfc1.INFO);
    addOperation(mtc1.INFO);
    addOperation(mfhc1.INFO);
    addOperation(mthc1.INFO);
    addOperation(mov_fmt.INFO);
    addOperation(movf.INFO);
    addOperation(movf_fmt.INFO);
    addOperation(movn_fmt.INFO);
    addOperation(movt.INFO);
    addOperation(movt_fmt.INFO);
    addOperation(movz_fmt.INFO);
    addOperation(cvtd_fmt.INFO);
    addOperation(cvtl_fmt.INFO);
    addOperation(cvtps_s.INFO);
    addOperation(cvts_pl.INFO);
    addOperation(cvts_pu.INFO);
    addOperation(cvts_fmt.INFO);
    addOperation(cvtw_fmt.INFO);
    addOperation(ceill_fmt.INFO);
    addOperation(ceilw_fmt.INFO);
    addOperation(alnvps_fmt.INFO);
    addOperation(floorl_fmt.INFO);
    addOperation(floorw_fmt.INFO);
    addOperation(pllps_s.INFO);
    addOperation(plups_s.INFO);
    addOperation(pulps_s.INFO);
    addOperation(puups_s.INFO);
    addOperation(roundl_fmt.INFO);
    addOperation(roundw_fmt.INFO);
    addOperation(truncl_fmt.INFO);
    addOperation(truncw_fmt.INFO);
    addOperation(cache.INFO);
    addOperation(mfhi.INFO);
    addOperation(mflo.INFO);
    addOperation(mthi.INFO);
    addOperation(mtlo.INFO);
    addOperation(tlbwi.INFO);
    addOperation(tlbwr.INFO);
    addOperation(wait.INFO);
    addOperation(ehb.INFO);
    addOperation(break_ins.INFO);
    addOperation(syscall.INFO);
    addOperation(teq.INFO);
    addOperation(teqi.INFO);
    addOperation(tge.INFO);
    addOperation(tgei.INFO);
    addOperation(tgeiu.INFO);
    addOperation(tgeu.INFO);
    addOperation(tlt.INFO);
    addOperation(tlti.INFO);
    addOperation(tltiu.INFO);
    addOperation(tltu.INFO);
    addOperation(tne.INFO);
    addOperation(tnei.INFO);
    addOperation(deret.INFO);
    addOperation(sdbbp.INFO);
    addOperation(di.INFO);
    addOperation(di2.INFO);
    addOperation(ei.INFO);
    addOperation(ei2.INFO);
    addOperation(eret.INFO);
    addOperation(dmfc0.INFO);
    addOperation(dmfc0_2.INFO);
    addOperation(dmtc0.INFO);
    addOperation(dmtc0_2.INFO);
    addOperation(mfc0.INFO);
    addOperation(mfc0_2.INFO);
    addOperation(mfc0_3.INFO);
    addOperation(mtc0.INFO);
    addOperation(mtc0_2.INFO);
    addOperation(mtc0_3.INFO);
    addOperation(tlbp.INFO);
    addOperation(tlbr.INFO);
    addOperation(dmfc2.INFO);
    addOperation(dmfc22.INFO);
    addOperation(dmtc2.INFO);
    addOperation(dmtc22.INFO);
    addOperation(mfc2.INFO);
    addOperation(mfc22.INFO);
    addOperation(mtc2.INFO);
    addOperation(mtc22.INFO);
    addOperation(ldc2.INFO);
    addOperation(lwc2.INFO);
    addOperation(nop.INFO);
    addOperation(ssnop.INFO);
    addOperation(mips64_load.INFO);
    addOperation(mips64_store.INFO);
    addOperation(lb.INFO);
    addOperation(lbu.INFO);
    addOperation(sb.INFO);
    addOperation(ld.INFO);
    addOperation(sd.INFO);
    addOperation(lh.INFO);
    addOperation(lhu.INFO);
    addOperation(sh.INFO);
    addOperation(lw.INFO);
    addOperation(lwu.INFO);
    addOperation(sw.INFO);
    addOperation(b.INFO);
    addOperation(bal.INFO);
    addOperation(balc.INFO);
    addOperation(bc.INFO);
    addOperation(beq.INFO);
    addOperation(beql.INFO);
    addOperation(bgez.INFO);
    addOperation(bgezal.INFO);
    addOperation(blezalc.INFO);
    addOperation(bgezalc.INFO);
    addOperation(bgtzalc.INFO);
    addOperation(bltzalc.INFO);
    addOperation(beqzalc.INFO);
    addOperation(bnezalc.INFO);
    addOperation(bgezall.INFO);
    addOperation(blezc.INFO);
    addOperation(bgezc.INFO);
    addOperation(bgtzc.INFO);
    addOperation(bltzc.INFO);
    addOperation(bgec.INFO);
    addOperation(blec.INFO);
    addOperation(bltc.INFO);
    addOperation(bgtc.INFO);
    addOperation(bgeuc.INFO);
    addOperation(bleuc.INFO);
    addOperation(bltuc.INFO);
    addOperation(bgtuc.INFO);
    addOperation(beqc.INFO);
    addOperation(bnec.INFO);
    addOperation(beqzc.INFO);
    addOperation(bnezc.INFO);
    addOperation(bgezl.INFO);
    addOperation(bgtz.INFO);
    addOperation(bgtzl.INFO);
    addOperation(blez.INFO);
    addOperation(blezl.INFO);
    addOperation(bltz.INFO);
    addOperation(bltzal.INFO);
    addOperation(bltzall.INFO);
    addOperation(bltzl.INFO);
    addOperation(bne.INFO);
    addOperation(bnel.INFO);
    addOperation(sum_input_overflow.INFO);
    addOperation(bovc.INFO);
    addOperation(bnvc.INFO);
    addOperation(j.INFO);
    addOperation(jal.INFO);
    addOperation(jalr2.INFO);
    addOperation(jalr.INFO);
    addOperation(jalr_hb2.INFO);
    addOperation(jalr_hb.INFO);
    addOperation(jalx.INFO);
    addOperation(jialc.INFO);
    addOperation(jic.INFO);
    addOperation(jr.INFO);
    addOperation(jr_hb.INFO);
    addOperation(mul_signed_words.INFO);
    addOperation(mul_unsigned_words.INFO);
    addOperation(add.INFO);
    addOperation(addi.INFO);
    addOperation(addiu.INFO);
    addOperation(addu.INFO);
    addOperation(addiupc.INFO);
    addOperation(aui.INFO);
    addOperation(clo_count_leading_ones.INFO);
    addOperation(clo.INFO);
    addOperation(clz.INFO);
    addOperation(div_reg.INFO);
    addOperation(mod_reg.INFO);
    addOperation(divu_reg.INFO);
    addOperation(modu_reg.INFO);
    addOperation(div.INFO);
    addOperation(divu.INFO);
    addOperation(madd.INFO);
    addOperation(maddu.INFO);
    addOperation(msub.INFO);
    addOperation(msubu.INFO);
    addOperation(mul.INFO);
    addOperation(mul_reg.INFO);
    addOperation(muh_reg.INFO);
    addOperation(mulu_reg.INFO);
    addOperation(muhu_reg.INFO);
    addOperation(mult.INFO);
    addOperation(multu.INFO);
    addOperation(sub.INFO);
    addOperation(subu.INFO);
    addOperation(slt.INFO);
    addOperation(slti.INFO);
    addOperation(sltiu.INFO);
    addOperation(sltu.INFO);
    addOperation(movn.INFO);
    addOperation(movz.INFO);
    addOperation(and.INFO);
    addOperation(andi.INFO);
    addOperation(nor.INFO);
    addOperation(or.INFO);
    addOperation(ori.INFO);
    addOperation(xor.INFO);
    addOperation(xori.INFO);
    addOperation(reverse_bits_in_byte.INFO);
    addOperation(bitswap.INFO);
    addOperation(rotr.INFO);
    addOperation(rotrv.INFO);
    addOperation(sll.INFO);
    addOperation(sllv.INFO);
    addOperation(sra.INFO);
    addOperation(srav.INFO);
    addOperation(srl.INFO);
    addOperation(srlv.INFO);
    addOperation(mul_signed_dwords.INFO);
    addOperation(mul_unsigned_dwords.INFO);
    addOperation(daui.INFO);
    addOperation(dahi.INFO);
    addOperation(dati.INFO);
    addOperation(dadd.INFO);
    addOperation(daddi.INFO);
    addOperation(daddiu.INFO);
    addOperation(daddu.INFO);
    addOperation(ddiv.INFO);
    addOperation(ddivu.INFO);
    addOperation(ddiv_reg.INFO);
    addOperation(dmod_reg.INFO);
    addOperation(ddivu_reg.INFO);
    addOperation(dmodu_reg.INFO);
    addOperation(dmul_reg.INFO);
    addOperation(dmuh_reg.INFO);
    addOperation(dmulu_reg.INFO);
    addOperation(dmuhu_reg.INFO);
    addOperation(dmult.INFO);
    addOperation(dmultu.INFO);
    addOperation(dsub.INFO);
    addOperation(dsubu.INFO);
    addOperation(dbitswap.INFO);
    addOperation(drotr.INFO);
    addOperation(drotr32.INFO);
    addOperation(drotrv.INFO);
    addOperation(dsll.INFO);
    addOperation(dsll32.INFO);
    addOperation(dsllv.INFO);
    addOperation(dsra.INFO);
    addOperation(dsra32.INFO);
    addOperation(dsrav.INFO);
    addOperation(dsrl.INFO);
    addOperation(dsrl32.INFO);
    addOperation(dsrlv.INFO);
    addOperation(ext.INFO);
    addOperation(ins.INFO);
    addOperation(dins.INFO);
    addOperation(dinsm.INFO);
    addOperation(dinsu.INFO);
    addOperation(wsbh.INFO);
    addOperation(lui.INFO);
    addOperation(instruction.INFO);
    addOperation(la.INFO);
  }
}
