/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;
import java.util.ArrayList;
import java.util.List;

/**
 * The {@code TranslateAddress} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TranslateAddress {
  private static TranslateAddress INSTANCE = null;

  public static TranslateAddress get() {
    if (null == INSTANCE) {
      INSTANCE = new TranslateAddress();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final PA TranslateAddress,
      final VA va) {
    return new Function(builder, callIndex++, TranslateAddress, va);
  }

  public static final class Function {
    public final PA TranslateAddress;
    public final VA va;

    private final PA pa;


    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction BRANCH_0;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction BRANCH_2;
    private final MmuAction BRANCH_3;
    private final MmuAction BRANCH_4;
    private final MmuAction BRANCH_5;
    private final MmuAction BRANCH_6;
    private final MmuAction BRANCH_7;
    private final MmuAction ASSIGN_0;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final PA TranslateAddress,
        final VA va) {
      final String name = String.format("TranslateAddress_%d", instanceIndex);
      this.TranslateAddress = TranslateAddress; 
      this.va = va; 

      this.pa = new PA(name + ".pa");
      builder.registerVariable(pa);

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(START, BRANCH_0, new MmuGuard(null, Arrays.<MmuSegment>asList(USEG.get()))));
      USEG.Function call_0 = USEG.get().newCall(builder, va, pa);
      builder.registerTransition(new MmuTransition(BRANCH_0, call_0.START));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(call_0.STOP, JOIN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(START, BRANCH_1, new MmuGuard(null, Arrays.<MmuSegment>asList(XKPHYS.get(), KSEG1.get(), KSEG0.get()))));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(BRANCH_1, BRANCH_2, new MmuGuard(null, Arrays.<MmuSegment>asList(KSEG0.get()))));
      KSEG0.Function call_1 = KSEG0.get().newCall(builder, va, pa);
      builder.registerTransition(new MmuTransition(BRANCH_2, call_1.START));
      builder.registerTransition(new MmuTransition(call_1.STOP, JOIN_0));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(BRANCH_1, BRANCH_3, new MmuGuard(null, Arrays.<MmuSegment>asList(XKPHYS.get(), USEG.get(), KSEG1.get()))));
      this.BRANCH_4 = new MmuAction(name + ".BRANCH_4");
      builder.registerAction(BRANCH_4);
      builder.registerTransition(new MmuTransition(BRANCH_3, BRANCH_4, new MmuGuard(null, Arrays.<MmuSegment>asList(KSEG1.get()))));
      KSEG1.Function call_2 = KSEG1.get().newCall(builder, va, pa);
      builder.registerTransition(new MmuTransition(BRANCH_4, call_2.START));
      builder.registerTransition(new MmuTransition(call_2.STOP, JOIN_0));
      this.BRANCH_5 = new MmuAction(name + ".BRANCH_5");
      builder.registerAction(BRANCH_5);
      builder.registerTransition(new MmuTransition(BRANCH_3, BRANCH_5, new MmuGuard(null, Arrays.<MmuSegment>asList(XKPHYS.get(), USEG.get(), KSEG0.get()))));
      this.BRANCH_6 = new MmuAction(name + ".BRANCH_6");
      builder.registerAction(BRANCH_6);
      builder.registerTransition(new MmuTransition(BRANCH_5, BRANCH_6, new MmuGuard(null, Arrays.<MmuSegment>asList(XKPHYS.get()))));
      XKPHYS.Function call_3 = XKPHYS.get().newCall(builder, va, pa);
      builder.registerTransition(new MmuTransition(BRANCH_6, call_3.START));
      builder.registerTransition(new MmuTransition(call_3.STOP, JOIN_0));
      this.BRANCH_7 = new MmuAction(name + ".BRANCH_7");
      builder.registerAction(BRANCH_7);
      builder.registerTransition(new MmuTransition(BRANCH_5, BRANCH_7, new MmuGuard(null, Arrays.<MmuSegment>asList(USEG.get(), KSEG1.get(), KSEG0.get()))));
      builder.registerTransition(new MmuTransition(BRANCH_7, JOIN_0));
      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", TranslateAddress, pa);
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(JOIN_0, ASSIGN_0));
      builder.registerTransition(new MmuTransition(ASSIGN_0, STOP));
    }
  }
}
