/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;
import java.util.ArrayList;
import java.util.List;

/**
 * The {@code USEG} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class USEG extends MmuSegment {
  private static USEG INSTANCE = null;

  public static USEG get() {
    if (null == INSTANCE) {
      INSTANCE = new USEG();
    }
    return INSTANCE;
  }

  private USEG() {
    this("USEG");
  }

  private USEG(final String name) {
    super(
        "USEG",
        VA.get(),
        PA.get(),
        0x0L,
        0x7fffffffL,
        true,
        null,
        null
    );
  }

  private int callIndex = 0;

  public final Function newCall(final MmuSubsystem.Builder builder, final VA va, final PA pa) {
    return new Function(builder, callIndex++, va, pa);
  }

  public static final class Function {
    public final VA va;
    public final PA pa;

    private final JTLB.Entry tlbEntry;
    private final IntegerVariable g;
    private final IntegerVariable v;
    private final IntegerVariable d;
    private final IntegerVariable c;
    private final IntegerVariable pfn;

    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction BRANCH_0;
    private final MmuAction ASSIGN_0;
    private final MmuAction GUARD_0;
    private final MmuAction GUARD_1;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction BRANCH_2;
    private final MmuAction ASSIGN_1;
    private final MmuAction BRANCH_3;
    private final MmuAction TLBMiss;
    private final MmuAction BRANCH_4;
    private final MmuAction ASSIGN_2;
    private final MmuAction ASSIGN_3;
    private final MmuAction ASSIGN_4;
    private final MmuAction ASSIGN_5;
    private final MmuAction ASSIGN_6;
    private final MmuAction JOIN_1;
    private final MmuAction BRANCH_5;
    private final MmuAction ASSIGN_7;
    private final MmuAction ASSIGN_8;
    private final MmuAction ASSIGN_9;
    private final MmuAction ASSIGN_10;
    private final MmuAction ASSIGN_11;
    private final MmuAction BRANCH_6;
    private final MmuAction ASSIGN_12;
    private final MmuAction ASSIGN_13;
    private final MmuAction JOIN_2;
    private final MmuAction BRANCH_7;
    private final MmuAction TLBInvalid;
    private final MmuAction ASSIGN_14;

    private Function(final MmuSubsystem.Builder builder, final int instanceIndex, final VA va, final PA pa) {
      this(builder, String.format("USEG_%d", instanceIndex), va, pa);
    }

    private Function(final MmuSubsystem.Builder builder, final String name, final VA va, final PA pa) {
      this.va = va;
      this.pa = pa;

      this.tlbEntry = new JTLB.Entry(name + ".tlbEntry");
      builder.registerVariable(tlbEntry);

      this.g = new IntegerVariable(name + ".g", 1);
      builder.registerVariable(g);

      this.v = new IntegerVariable(name + ".v", 1);
      builder.registerVariable(v);

      this.d = new IntegerVariable(name + ".d", 1);
      builder.registerVariable(d);

      this.c = new IntegerVariable(name + ".c", 3);
      builder.registerVariable(c);

      this.pfn = new IntegerVariable(name + ".pfn", 24);
      builder.registerVariable(pfn);


      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(START, BRANCH_0, new MmuGuard(new MmuBufferAccess(DTLB.get(), DTLB.get().getAddress(), DTLB.get(), 0), BufferAccessEvent.HIT)));
      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBufferAccess(DTLB.get(), DTLB.get().getAddress(), DTLB.get(), 0), tlbEntry, DTLB.get());
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(BRANCH_0, ASSIGN_0));
      this.GUARD_0 = new MmuAction(name + ".GUARD_0");
      builder.registerAction(GUARD_0);
      builder.registerTransition(new MmuTransition(ASSIGN_0, GUARD_0, new MmuGuard(new MmuBufferAccess(JTLB.get(), JTLB.get().getAddress(), JTLB.get(), 0), BufferAccessEvent.HIT)));
      this.GUARD_1 = new MmuAction(name + ".GUARD_1");
      builder.registerAction(GUARD_1);
      builder.registerTransition(new MmuTransition(GUARD_0, GUARD_1, new MmuGuard(MmuCondition.eq(JTLB.get(), tlbEntry))));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(GUARD_1, JOIN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(START, BRANCH_1, new MmuGuard(new MmuBufferAccess(DTLB.get(), DTLB.get().getAddress(), DTLB.get(), 0), BufferAccessEvent.MISS)));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(BRANCH_1, BRANCH_2, new MmuGuard(new MmuBufferAccess(JTLB.get(), JTLB.get().getAddress(), JTLB.get(), 0), BufferAccessEvent.HIT)));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBufferAccess(JTLB.get(), JTLB.get().getAddress(), JTLB.get(), 0), tlbEntry, JTLB.get());
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(BRANCH_2, ASSIGN_1));
      builder.registerTransition(new MmuTransition(ASSIGN_1, JOIN_0));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(BRANCH_1, BRANCH_3, new MmuGuard(new MmuBufferAccess(JTLB.get(), JTLB.get().getAddress(), JTLB.get(), 0), BufferAccessEvent.MISS)));
      this.TLBMiss = new MmuAction(name + ".TLBMiss");
      builder.registerAction(TLBMiss);
      builder.registerTransition(new MmuTransition(BRANCH_3, TLBMiss));
      this.BRANCH_4 = new MmuAction(name + ".BRANCH_4");
      builder.registerAction(BRANCH_4);
      builder.registerTransition(new MmuTransition(JOIN_0, BRANCH_4, new MmuGuard(MmuConditionAtom.eq(va.value.field(12, 12), new BigInteger("0", 10)))));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(g, tlbEntry.G0));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(BRANCH_4, ASSIGN_2));
      this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", new MmuBinding(v, tlbEntry.V0));
      builder.registerAction(ASSIGN_3);
      builder.registerTransition(new MmuTransition(ASSIGN_2, ASSIGN_3));
      this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBinding(d, tlbEntry.D0));
      builder.registerAction(ASSIGN_4);
      builder.registerTransition(new MmuTransition(ASSIGN_3, ASSIGN_4));
      this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", new MmuBinding(c, tlbEntry.C0));
      builder.registerAction(ASSIGN_5);
      builder.registerTransition(new MmuTransition(ASSIGN_4, ASSIGN_5));
      this.ASSIGN_6 = new MmuAction(name + ".ASSIGN_6", new MmuBinding(pfn, tlbEntry.PFN0));
      builder.registerAction(ASSIGN_6);
      builder.registerTransition(new MmuTransition(ASSIGN_5, ASSIGN_6));
      this.JOIN_1 = new MmuAction(name + ".JOIN_1");
      builder.registerAction(JOIN_1);
      builder.registerTransition(new MmuTransition(ASSIGN_6, JOIN_1));
      this.BRANCH_5 = new MmuAction(name + ".BRANCH_5");
      builder.registerAction(BRANCH_5);
      builder.registerTransition(new MmuTransition(JOIN_0, BRANCH_5, new MmuGuard(MmuConditionAtom.neq(va.value.field(12, 12), new BigInteger("0", 10)))));
      this.ASSIGN_7 = new MmuAction(name + ".ASSIGN_7", new MmuBinding(g, tlbEntry.G1));
      builder.registerAction(ASSIGN_7);
      builder.registerTransition(new MmuTransition(BRANCH_5, ASSIGN_7));
      this.ASSIGN_8 = new MmuAction(name + ".ASSIGN_8", new MmuBinding(v, tlbEntry.V1));
      builder.registerAction(ASSIGN_8);
      builder.registerTransition(new MmuTransition(ASSIGN_7, ASSIGN_8));
      this.ASSIGN_9 = new MmuAction(name + ".ASSIGN_9", new MmuBinding(d, tlbEntry.D1));
      builder.registerAction(ASSIGN_9);
      builder.registerTransition(new MmuTransition(ASSIGN_8, ASSIGN_9));
      this.ASSIGN_10 = new MmuAction(name + ".ASSIGN_10", new MmuBinding(c, tlbEntry.C1));
      builder.registerAction(ASSIGN_10);
      builder.registerTransition(new MmuTransition(ASSIGN_9, ASSIGN_10));
      this.ASSIGN_11 = new MmuAction(name + ".ASSIGN_11", new MmuBinding(pfn, tlbEntry.PFN1));
      builder.registerAction(ASSIGN_11);
      builder.registerTransition(new MmuTransition(ASSIGN_10, ASSIGN_11));
      builder.registerTransition(new MmuTransition(ASSIGN_11, JOIN_1));
      this.BRANCH_6 = new MmuAction(name + ".BRANCH_6");
      builder.registerAction(BRANCH_6);
      builder.registerTransition(new MmuTransition(JOIN_1, BRANCH_6, new MmuGuard(MmuConditionAtom.eq(v, new BigInteger("1", 10)))));
      this.ASSIGN_12 = new MmuAction(name + ".ASSIGN_12", new MmuBinding(pa.value, MmuExpression.rcat(pfn.field(0, 23), va.value.field(0, 11))));
      builder.registerAction(ASSIGN_12);
      builder.registerTransition(new MmuTransition(BRANCH_6, ASSIGN_12));
      this.ASSIGN_13 = new MmuAction(name + ".ASSIGN_13", new MmuBinding(pa.cca, c));
      builder.registerAction(ASSIGN_13);
      builder.registerTransition(new MmuTransition(ASSIGN_12, ASSIGN_13));
      this.JOIN_2 = new MmuAction(name + ".JOIN_2");
      builder.registerAction(JOIN_2);
      builder.registerTransition(new MmuTransition(ASSIGN_13, JOIN_2));
      this.BRANCH_7 = new MmuAction(name + ".BRANCH_7");
      builder.registerAction(BRANCH_7);
      builder.registerTransition(new MmuTransition(JOIN_1, BRANCH_7, new MmuGuard(MmuConditionAtom.neq(v, new BigInteger("1", 10)))));
      this.TLBInvalid = new MmuAction(name + ".TLBInvalid");
      builder.registerAction(TLBInvalid);
      builder.registerTransition(new MmuTransition(BRANCH_7, TLBInvalid));
      this.ASSIGN_14 = new MmuAction(name + ".ASSIGN_14", new MmuBufferAccess(DTLB.get(), DTLB.get().getAddress(), DTLB.get(), 0));
      builder.registerAction(ASSIGN_14);
      builder.registerTransition(new MmuTransition(JOIN_2, ASSIGN_14));
      builder.registerTransition(new MmuTransition(ASSIGN_14, STOP));
    }
  }
}
