/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class CPRGET extends IsaPrimitive {
  public static final String NAME = "CPRGET";

  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.MODE,
          "CPRGET",
          CPRGET.class,
          null
          );
      addArgument("i", Type.CARD(8));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new CPRGET(i);
    }
  }

  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate i;

  public CPRGET(final Immediate i) {
    this.i = i;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tempCPR.access().store(pe__.CPR.access(i.access().load()).load());
  }

}