/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class C_cond2 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "C_cond2",
          C_cond2.class,
          null
          );
      addArgument("cond_value", FPU_COND_TYPE.INFO);
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive cond_value = (IsaPrimitive) getArgument("cond_value", args);
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new C_cond2(cond_value, op_fmt, fs, ft);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "C_cond2",
          instruction.class,
          null
          );
      addArgument("cond_value", FPU_COND_TYPE.INFO);
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive cond_value = (IsaPrimitive) getArgument("cond_value", args);
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new instruction(
        new C_cond2(
          cond_value,
          op_fmt,
          fs,
          ft
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive cond_value;
  public final IsaPrimitive op_fmt;
  public final FR fs;
  public final FR ft;

  public C_cond2(final IsaPrimitive cond_value, final IsaPrimitive op_fmt, final FR fs, final FR ft) {
    assert FPU_COND_TYPE.INFO.isSupported(cond_value);
    assert FMT_FORMAT.INFO.isSupported(op_fmt);
    assert FR.INFO.isSupported(fs);
    assert FR.INFO.isSupported(ft);
    this.cond_value = cond_value;
    this.op_fmt = op_fmt;
    this.fs = fs;
    this.ft = ft;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.%s.%s %s, %s", cond_value.syntax(vars__), op_fmt.syntax(vars__), fs.syntax(vars__), ft.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010001%5s%5s%5s%3s0011%4s", op_fmt.image(vars__), ft.image(vars__), fs.image(vars__), Data.valueOf(Type.CARD(3), 0x0).toString(), cond_value.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new C_cond(cond_value, op_fmt, new Immediate(Data.valueOf(Type.CARD(3), 0x0)), fs, ft).execute(pe__, vars__);
  }
}