/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class StoreFPR extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "StoreFPR",
          StoreFPR.class,
          null
          );
      addArgument("fpu_reg_number", Type.CARD(5));
      addArgument("fmt_value", Type.CARD(5));
      addArgument("value", Type.CARD(64));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate fpu_reg_number = (Immediate) getArgument("fpu_reg_number", args);
      final Immediate fmt_value = (Immediate) getArgument("fmt_value", args);
      final Immediate value = (Immediate) getArgument("value", args);

      return new StoreFPR(fpu_reg_number, fmt_value, value);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate fpu_reg_number;
  public final Immediate fmt_value;
  public final Immediate value;

  public StoreFPR(final Immediate fpu_reg_number, final Immediate fmt_value, final Immediate value) {
    assert Type.CARD(5).equals(fpu_reg_number.getType());
    assert Type.CARD(5).equals(fmt_value.getType());
    assert Type.CARD(64).equals(value.getType());
    this.fpu_reg_number = fpu_reg_number;
    this.fmt_value = fmt_value;
    this.value = value;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp0.access().store(Data.valueOf(WORD, 0x0));
    if ((fmt_value.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)) || fmt_value.access().load().equals(Data.valueOf(Type.CARD(5), 0x4)))) {
      pe__.FPR.access(fpu_reg_number.access().load()).store(Location.concat(vars__.temp0.access().bitField(31, 0), value.access().bitField(31, 0)));
    } else if (fmt_value.access().load().equals(Data.valueOf(Type.CARD(5), 0x1))) {
      if (false) {
        if (!fpu_reg_number.access().bitField(0, 0).load().equals(Data.valueOf(Type.CARD(1), 0x0))) {
          Execution.unpredicted();
        } else {
          pe__.FPR.access(fpu_reg_number.access().load()).store(Location.concat(vars__.temp0.access().bitField(31, 0), value.access().bitField(31, 0)));
          pe__.FPR.access(fpu_reg_number.access().load().add(Data.valueOf(Type.CARD(5), 0x1))).store(Location.concat(vars__.temp0.access().bitField(31, 0), value.access().bitField(63, 32)));
        }
      } else {
        pe__.FPR.access(fpu_reg_number.access().load()).store(value.access().bitField(63, 0).load());
      }
    } else if (fmt_value.access().load().equals(Data.valueOf(Type.CARD(5), 0x5))) {
      if (false) {
        Execution.unpredicted();
      } else {
        pe__.FPR.access(fpu_reg_number.access().load()).store(value.access().bitField(63, 0).load());
      }
    }
  }
}