/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class beqc extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "beqc",
          beqc.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new beqc(rs, rt, offset);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "beqc",
          instruction.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction(
        new beqc(
          rs,
          rt,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rs;
  public final R rt;
  public final Immediate offset;

  public beqc(final R rs, final R rt, final Immediate offset) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    this.rs = rs;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("beqc %s, %s, <label>%d", rs.syntax(vars__), rt.syntax(vars__), offset.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("001000%5s%5s%16s", rs.image(vars__), rt.image(vars__), offset.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x1));
    if ((((rs.i.access().load().compareTo(rt.i.access().load()) < 0) || rt.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0))) || rs.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)))) {
      Execution.undefined();
    } else {
      if (rs.access(pe__, vars__).load().equals(rt.access(pe__, vars__).load())) {
        pe__.COMPACT_BRANCH.access().store(Data.valueOf(BIT, 0x1));
        pe__.NEXTPC.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)).add(Data.signExtend(DWORD, offset.access().load()).shiftLeft(Data.valueOf(DWORD, 0x2))));
      }
    }
  }
}