/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class cache extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "cache",
          cache.class,
          null
          );
      addArgument("operation", Type.CARD(5));
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate operation = (Immediate) getArgument("operation", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new cache(operation, offset, base);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "cache",
          instruction.class,
          null
          );
      addArgument("operation", Type.CARD(5));
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate operation = (Immediate) getArgument("operation", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new instruction(
        new cache(
          operation,
          offset,
          base
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate operation;
  public final Immediate offset;
  public final R base;

  public cache(final Immediate operation, final Immediate offset, final R base) {
    assert Type.CARD(5).equals(operation.getType());
    assert SHORT.equals(offset.getType());
    assert R.INFO.isSupported(base);
    this.operation = operation;
    this.offset = offset;
    this.base = base;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("cache %d, %d(%s)", operation.access().load().bigIntegerValue(), offset.access().load().bigIntegerValue(), base.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("00000000000000000000000000000000");
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
  }
}