/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class daddi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "daddi",
          daddi.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("immediate", SHORT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new daddi(rt, rs, immediate);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "daddi",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("immediate", SHORT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new instruction(
        new daddi(
          rt,
          rs,
          immediate
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate immediate;

  public daddi(final R rt, final R rs, final Immediate immediate) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(immediate.getType());
    this.rt = rt;
    this.rs = rs;
    this.immediate = immediate;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("daddi %s, %s, %d", rt.syntax(vars__), rs.syntax(vars__), immediate.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("011000%5s%5s%16s", rt.image(vars__), rs.image(vars__), immediate.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.temp65.access().store(Location.concat(rs.access(pe__, vars__).bitField(63, 63), rs.access(pe__, vars__).bitField(63, 0)).load().add(Data.signExtend(Type.CARD(65), immediate.access().load())));
    if (!vars__.temp65.access().bitField(64, 64).load().equals(vars__.temp65.access().bitField(63, 63).load())) {
      pe__.C0_EPC.access().store(pe__.CIA.access().load());
      Execution.exception("IntegerOverflow");
    } else {
      rt.access(pe__, vars__).store(vars__.temp65.access().bitField(63, 0).load());
    }
  }
}