/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class dbitswap extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "dbitswap",
          dbitswap.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("rt", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);

      return new dbitswap(rd, rt);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "dbitswap",
          instruction.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("rt", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);

      return new instruction(
        new dbitswap(
          rd,
          rt
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final R rt;

  public dbitswap(final R rd, final R rt) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rt);
    this.rd = rd;
    this.rt = rt;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("dbitswap %s, %s", rd.syntax(vars__), rt.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01111100000%5s%5s00000100100", rt.image(vars__), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(63, 56))).execute(pe__, vars__);
    vars__.temp64.access().bitField(63, 56).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(55, 48))).execute(pe__, vars__);
    vars__.temp64.access().bitField(55, 48).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(47, 40))).execute(pe__, vars__);
    vars__.temp64.access().bitField(47, 40).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(39, 32))).execute(pe__, vars__);
    vars__.temp64.access().bitField(39, 32).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(31, 24))).execute(pe__, vars__);
    vars__.temp64.access().bitField(31, 24).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(23, 16))).execute(pe__, vars__);
    vars__.temp64.access().bitField(23, 16).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(15, 8))).execute(pe__, vars__);
    vars__.temp64.access().bitField(15, 8).store(vars__.temp_reverse.access().load());
    new reverse_bits_in_byte(new Immediate(rt.access(pe__, vars__).bitField(7, 0))).execute(pe__, vars__);
    vars__.temp64.access().bitField(7, 0).store(vars__.temp_reverse.access().load());
    rd.access(pe__, vars__).store(vars__.temp64.access().load());
  }
}