/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class dmodu_reg extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "dmodu_reg",
          dmodu_reg.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new dmodu_reg(rd, rs, rt);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "dmodu_reg",
          instruction.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new instruction(
        new dmodu_reg(
          rd,
          rs,
          rt
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final R rs;
  public final R rt;

  public dmodu_reg(final R rd, final R rs, final R rt) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    this.rd = rd;
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("dmodu %s, %s, %s", rd.syntax(vars__), rs.syntax(vars__), rt.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("000000%5s%5s%5s00011011111", rs.image(vars__), rt.image(vars__), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if ((!Data.signExtend(WORD, rs.access(pe__, vars__).bitField(31, 31).load()).equals(rs.access(pe__, vars__).bitField(63, 32).load()) || !Data.signExtend(WORD, rt.access(pe__, vars__).bitField(31, 31).load()).equals(rt.access(pe__, vars__).bitField(63, 32).load()))) {
      Execution.unpredicted();
    }
    if (false) {
      Execution.trace("SignalException(ReservedInstruction)");
    }
    vars__.temp64_1.access().store(rs.access(pe__, vars__).load());
    vars__.temp64_2.access().store(rt.access(pe__, vars__).load());
    vars__.temp64.access().store(vars__.temp64_1.access().load().mod(vars__.temp64_2.access().load()));
    rd.access(pe__, vars__).store(vars__.temp64.access().load());
  }
}