/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class eret extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "eret",
          eret.class,
          null
          );
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      return new eret();
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "eret",
          instruction.class,
          null
          );
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      return new instruction(
        new eret()
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public eret() {
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("eret");
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01000010000000000000000000011000");
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if (pe__.C0_STATUS_ERL.access().load().equals(Data.valueOf(BIT, 0x1))) {
      vars__.temp64.access().store(pe__.C0_ERROR_EPC.access().load());
      pe__.C0_STATUS_ERL.access().store(Data.valueOf(BIT, 0x0));
    } else {
      vars__.temp64.access().store(pe__.C0_EPC.access().load());
      pe__.C0_STATUS_EXL.access().store(Data.valueOf(BIT, 0x0));
      if (true && (pe__.C0_SRSCTL_HSS.access().load().compareTo(Data.valueOf(Type.CARD(4), 0x0)) > 0) && pe__.C0_STATUS_BEV.access().load().equals(Data.valueOf(BIT, 0x0))) {
        pe__.C0_SRSCTL_CSS.access().store(pe__.C0_SRSCTL_PSS.access().load());
      }
    }
    if ((pe__.C0_CONFIG3_ISA.access().load().compareTo(Data.valueOf(Type.CARD(2), 0x0)) > 0)) {
      vars__.temp_bit.access().store(Data.valueOf(BIT, 0x0));
      pe__.NEXTPC.access().store(Location.concat(vars__.temp64.access().bitField(63, 1), vars__.temp_bit.access().bitField(0, 0)));
      pe__.ISAMode.access().store(vars__.temp64.access().bitField(0, 0).load());
    } else {
      pe__.NEXTPC.access().store(vars__.temp64.access().load());
    }
    pe__.LLbit.access().store(Data.valueOf(BIT, 0x0));
  }
}