/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class instruction extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "instruction",
          instruction.class,
          null
          );
      addArgument("operation", Op.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive operation = (IsaPrimitive) getArgument("operation", args);

      return new instruction(operation);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive operation;

  public instruction(final IsaPrimitive operation) {
    assert Op.INFO.isSupported(operation);
    this.operation = operation;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return operation.syntax(vars__);
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return operation.image(vars__);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    pe__.GPR.access(0).store(Data.valueOf(DWORD, 0x0));
    vars__.last_branch_instruction.access().store(pe__.BRANCH_INSTRUCTION.access().load());
    vars__.is_delay_slot.access().store(pe__.BRANCH.access().load());
    vars__.jump_address.access().store(pe__.NEXTPC.access().load());
    pe__.BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x0));
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x0));
    pe__.NEXTPC.access().store(Data.valueOf(DWORD, 0x0));
    if (pe__.SKIPOP.access().load().equals(Data.valueOf(BIT, 0x0))) {
      operation.execute(pe__, vars__);
    } else {
      pe__.SKIPOP.access().store(Data.valueOf(BIT, 0x0));
    }
    if (pe__.BRANCH_INSTRUCTION.access().load().equals(Data.valueOf(BIT, 0x1)) && vars__.last_branch_instruction.access().load().equals(Data.valueOf(BIT, 0x1))) {
      Execution.unpredicted();
    }
    if (vars__.is_delay_slot.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.CIA.access().store(vars__.jump_address.access().load());
    } else {
      pe__.CIA.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
  }
}