/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class la extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "la",
          la.class,
          null
          );
      addArgument("rd", R.INFO);
      addArgument("addr", DWORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rd = (R) getArgument("rd", args);
      final Immediate addr = (Immediate) getArgument("addr", args);

      return new la(rd, addr);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rd;
  public final Immediate addr;

  public la(final R rd, final Immediate addr) {
    assert R.INFO.isSupported(rd);
    assert DWORD.equals(addr.getType());
    this.rd = rd;
    this.addr = addr;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("la %s, <label>%d", rd.syntax(vars__), addr.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s%s%s%s%s", new lui(rd, new Immediate(addr.access().bitField(63, 48))).image(vars__), new ori(rd, rd, new Immediate(addr.access().bitField(47, 32))).image(vars__), new dsll32(rd, rd, new Immediate(Data.valueOf(Type.CARD(5), 0x0))).image(vars__), new lui(rd, new Immediate(addr.access().bitField(31, 16))).image(vars__), new ori(rd, rd, new Immediate(addr.access().bitField(15, 0))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new instruction(new lui(rd, new Immediate(addr.access().bitField(63, 48)))).execute(pe__, vars__);
    new instruction(new ori(rd, rd, new Immediate(addr.access().bitField(47, 32)))).execute(pe__, vars__);
    new instruction(new dsll32(rd, rd, new Immediate(Data.valueOf(Type.CARD(5), 0x0)))).execute(pe__, vars__);
    new instruction(new lui(rd, new Immediate(addr.access().bitField(31, 16)))).execute(pe__, vars__);
    new instruction(new ori(rd, rd, new Immediate(addr.access().bitField(15, 0)))).execute(pe__, vars__);
  }
}