/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class mips64_store extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "mips64_store",
          mips64_store.class,
          null
          );
      addArgument("store_op", Type.CARD(4));
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate store_op = (Immediate) getArgument("store_op", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new mips64_store(store_op, rt, offset, base);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate store_op;
  public final R rt;
  public final Immediate offset;
  public final R base;

  public mips64_store(final Immediate store_op, final R rt, final Immediate offset, final R base) {
    assert Type.CARD(4).equals(store_op.getType());
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    assert R.INFO.isSupported(base);
    this.store_op = store_op;
    this.rt = rt;
    this.offset = offset;
    this.base = base;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp_address.access().store(base.access(pe__, vars__).load().add(Data.signExtend(DWORD, offset.access().load())));
    vars__.temp64.access().store(pe__.MEM.access(vars__.temp_address.access().load().shiftRight(Data.valueOf(DWORD, 0x3))).load());
    vars__.temp_byte_offset.access().store(vars__.temp_address.access().bitField(2, 0).load().xor(Data.valueOf(Type.CARD(3), 0x0)));
    vars__.store_address_error.access().store(Data.zeroExtend(WORD, vars__.temp_byte_offset.access().bitField(2, 0).load()).mod(Data.zeroExtend(WORD, store_op.access().load())));
    if ((vars__.store_address_error.access().load().compareTo(Data.valueOf(WORD, 0x0)) > 0)) {
      pe__.C0_EPC.access().store(pe__.CIA.access().load());
      Execution.exception("AddressError: mips64_store");
      Execution.trace("type = 0x%x", store_op.access().load().bigIntegerValue(false));
    }
    vars__.temp.access().store(Data.valueOf(WORD, 0x8).multiply(Data.zeroExtend(WORD, vars__.temp_byte_offset.access().bitField(2, 0).load())));
    vars__.temp64_1.access().store(Data.valueOf(DWORD, new BigInteger("ffffffffffffffff", 16)));
    vars__.temp64_1.access().store(vars__.temp64_1.access().load().shiftRight(Data.valueOf(WORD, 0x40).subtract(Data.valueOf(WORD, 0x8).multiply(Data.zeroExtend(WORD, store_op.access().load())))));
    vars__.temp64_1.access().store(vars__.temp64_1.access().load().shiftLeft(vars__.temp.access().load()));
    vars__.temp64_0.access().store(rt.access(pe__, vars__).bitField(63, 0).load().shiftLeft(vars__.temp.access().load()));
    vars__.temp64_0.access().store(vars__.temp64_0.access().load().and(vars__.temp64_1.access().load()));
    vars__.temp64_1.access().store(vars__.temp64_1.access().load().not());
    vars__.temp64_1.access().store(vars__.temp64_1.access().load().and(vars__.temp64.access().load()));
    vars__.temp64_2.access().store(vars__.temp64_0.access().load().or(vars__.temp64_1.access().load()));
    pe__.MEM.access(vars__.temp_address.access().load().shiftRight(Data.valueOf(DWORD, 0x3))).store(vars__.temp64_2.access().load());
  }
}