/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class movf_fmt extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "movf_fmt",
          movf_fmt.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("cc", Type.CARD(3));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new movf_fmt(op_fmt, fd, fs, cc);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "movf_fmt",
          instruction.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("cc", Type.CARD(3));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new instruction(
        new movf_fmt(
          op_fmt,
          fd,
          fs,
          cc
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive op_fmt;
  public final FR fd;
  public final FR fs;
  public final Immediate cc;

  public movf_fmt(final IsaPrimitive op_fmt, final FR fd, final FR fs, final Immediate cc) {
    assert FMT_FORMAT.INFO.isSupported(op_fmt);
    assert FR.INFO.isSupported(fd);
    assert FR.INFO.isSupported(fs);
    assert Type.CARD(3).equals(cc.getType());
    this.op_fmt = op_fmt;
    this.fd = fd;
    this.fs = fs;
    this.cc = cc;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("movf.%s %s, %s, %d", op_fmt.syntax(vars__), fd.syntax(vars__), fs.syntax(vars__), cc.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010001%5s%3s00%5s%5s010001", op_fmt.image(vars__), cc.access().load().toString(), fs.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new FPConditionCode(cc).execute(pe__, vars__);
    if (pe__.FPConditionCode_value.access().load().equals(Data.valueOf(BIT, 0x0))) {
      if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x10))) {
        fd.access(pe__, vars__).bitField(31, 31).store(fs.access(pe__, vars__).bitField(31, 31).load());
      } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x11))) {
        fd.access(pe__, vars__).bitField(63, 0).store(fs.access(pe__, vars__).bitField(63, 0).load());
      } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x16))) {
        if (cc.access().bitField(0, 0).load().equals(Data.valueOf(BIT, 0x0))) {
          fd.access(pe__, vars__).bitField(31, 0).store(fs.access(pe__, vars__).bitField(31, 0).load());
          new FPConditionCode(new Immediate(cc.access().load().add(Data.valueOf(Type.CARD(3), 0x1)))).execute(pe__, vars__);
          if (pe__.FPConditionCode_value.access().load().equals(Data.valueOf(BIT, 0x0))) {
            fd.access(pe__, vars__).bitField(63, 32).store(fs.access(pe__, vars__).bitField(63, 32).load());
          }
        } else {
          Execution.unpredicted();
        }
      } else {
        Execution.unpredicted();
      }
    }
  }
}