/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class msub_fmt extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "msub_fmt",
          msub_fmt.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fr", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fr = (FR) getArgument("fr", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new msub_fmt(op_fmt, fd, fr, fs, ft);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "msub_fmt",
          instruction.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fr", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fr = (FR) getArgument("fr", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new instruction(
        new msub_fmt(
          op_fmt,
          fd,
          fr,
          fs,
          ft
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive op_fmt;
  public final FR fd;
  public final FR fr;
  public final FR fs;
  public final FR ft;

  public msub_fmt(final IsaPrimitive op_fmt, final FR fd, final FR fr, final FR fs, final FR ft) {
    assert FMT_FORMAT.INFO.isSupported(op_fmt);
    assert FR.INFO.isSupported(fd);
    assert FR.INFO.isSupported(fr);
    assert FR.INFO.isSupported(fs);
    assert FR.INFO.isSupported(ft);
    this.op_fmt = op_fmt;
    this.fd = fd;
    this.fr = fr;
    this.fs = fs;
    this.ft = ft;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    op_fmt.init(vars__);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("msub.%s %s, %s, %s, %s", op_fmt.syntax(vars__), fd.syntax(vars__), fr.syntax(vars__), fs.syntax(vars__), ft.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010011%5s%5s%5s%5s101%3s", fr.image(vars__), ft.image(vars__), fs.image(vars__), fd.image(vars__), vars__.fmt_fpu.access().bitField(4, 2).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    op_fmt.execute(pe__, vars__);
    if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x10))) {
      vars__.temp_fp_s.access().store(Data.intToFloat(FLOAT32, fs.access(pe__, vars__).bitField(31, 0).load()).multiply(Data.intToFloat(FLOAT32, ft.access(pe__, vars__).bitField(31, 0).load())).subtract(Data.intToFloat(FLOAT32, fr.access(pe__, vars__).bitField(31, 0).load())));
      fd.access(pe__, vars__).bitField(31, 0).store(Data.floatToInt(WORD, vars__.temp_fp_s.access().load()));
    } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x11))) {
      vars__.temp_fp_d.access().store(Data.intToFloat(FLOAT64, fs.access(pe__, vars__).bitField(63, 0).load()).multiply(Data.intToFloat(FLOAT64, ft.access(pe__, vars__).bitField(63, 0).load())).subtract(Data.intToFloat(FLOAT64, fr.access(pe__, vars__).bitField(63, 0).load())));
      fd.access(pe__, vars__).bitField(63, 0).store(Data.floatToInt(DWORD, vars__.temp_fp_d.access().load()));
    } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x16))) {
      vars__.temp_fp_s.access().store(Data.intToFloat(FLOAT32, fs.access(pe__, vars__).bitField(31, 0).load()).multiply(Data.intToFloat(FLOAT32, ft.access(pe__, vars__).bitField(31, 0).load())).subtract(Data.intToFloat(FLOAT32, fr.access(pe__, vars__).bitField(31, 0).load())));
      fd.access(pe__, vars__).bitField(31, 0).store(Data.floatToInt(WORD, vars__.temp_fp_s.access().load()));
      vars__.temp_fp_s.access().store(Data.intToFloat(FLOAT32, fs.access(pe__, vars__).bitField(63, 32).load()).multiply(Data.intToFloat(FLOAT32, ft.access(pe__, vars__).bitField(63, 32).load())).subtract(Data.intToFloat(FLOAT32, fr.access(pe__, vars__).bitField(63, 32).load())));
      fd.access(pe__, vars__).bitField(63, 32).store(Data.floatToInt(WORD, vars__.temp_fp_s.access().load()));
    } else {
      Execution.unpredicted();
    }
  }
}