/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class mul_signed_dwords extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "mul_signed_dwords",
          mul_signed_dwords.class,
          null
          );
      addArgument("temp_a", DWORD);
      addArgument("temp_b", DWORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate temp_a = (Immediate) getArgument("temp_a", args);
      final Immediate temp_b = (Immediate) getArgument("temp_b", args);

      return new mul_signed_dwords(temp_a, temp_b);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate temp_a;
  public final Immediate temp_b;

  public mul_signed_dwords(final Immediate temp_a, final Immediate temp_b) {
    assert DWORD.equals(temp_a.getType());
    assert DWORD.equals(temp_b.getType());
    this.temp_a = temp_a;
    this.temp_b = temp_b;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp128_1.access().store(Data.signExtend(QWORD, temp_a.access().load()));
    vars__.temp128_2.access().store(Data.signExtend(QWORD, temp_b.access().load()));
    vars__.temp128.access().store(Data.cast(Type.INT(128), vars__.temp128_1.access().load()).multiply(Data.cast(Type.INT(128), vars__.temp128_2.access().load())));
  }
}