/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class pulps_s extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "pulps_s",
          pulps_s.class,
          null
          );
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new pulps_s(fd, fs, ft);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "pulps_s",
          instruction.class,
          null
          );
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new instruction(
        new pulps_s(
          fd,
          fs,
          ft
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR fd;
  public final FR fs;
  public final FR ft;

  public pulps_s(final FR fd, final FR fs, final FR ft) {
    assert FR.INFO.isSupported(fd);
    assert FR.INFO.isSupported(fs);
    assert FR.INFO.isSupported(ft);
    this.fd = fd;
    this.fs = fs;
    this.ft = ft;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("pul.ps.s %s, %s, %s", fd.syntax(vars__), fs.syntax(vars__), ft.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01000110110%5s%5s%5s101110", ft.image(vars__), fs.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    fd.access(pe__, vars__).bitField(63, 0).store(Location.concat(fs.access(pe__, vars__).bitField(63, 32), ft.access(pe__, vars__).bitField(31, 0)));
  }
}