/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class sum_input_overflow extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "sum_input_overflow",
          sum_input_overflow.class,
          null
          );
      addArgument("temp_a", DWORD);
      addArgument("temp_b", DWORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate temp_a = (Immediate) getArgument("temp_a", args);
      final Immediate temp_b = (Immediate) getArgument("temp_b", args);

      return new sum_input_overflow(temp_a, temp_b);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate temp_a;
  public final Immediate temp_b;

  public sum_input_overflow(final Immediate temp_a, final Immediate temp_b) {
    assert DWORD.equals(temp_a.getType());
    assert DWORD.equals(temp_b.getType());
    this.temp_a = temp_a;
    this.temp_b = temp_b;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.temp_bit.access().store(Data.valueOf(BIT, 0x0));
    if ((!Data.signExtend(WORD, temp_a.access().bitField(31, 31).load()).equals(temp_a.access().bitField(63, 32).load()) || !Data.signExtend(WORD, temp_b.access().bitField(31, 31).load()).equals(temp_b.access().bitField(63, 32).load()))) {
      vars__.temp_bit.access().store(Data.valueOf(BIT, 0x1));
    }
    vars__.temp33.access().store(Location.concat(temp_a.access().bitField(31, 31), temp_a.access().bitField(31, 0)).load().add(Location.concat(temp_b.access().bitField(31, 31), temp_b.access().bitField(31, 0)).load()));
    if (!vars__.temp33.access().bitField(32, 32).load().equals(vars__.temp33.access().bitField(31, 31).load())) {
      vars__.temp_bit.access().store(Data.valueOf(BIT, 0x1));
    }
  }
}