/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class JMP_R16 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "JMP_R16",
          JMP_R16.class,
          null
          );
      addArgument("rel", GPR16.INFO);
      addShortcut(new Info_x86(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final GPR16 rel = (GPR16) getArgument("rel", args);

      return new JMP_R16(rel);
    }
  }
  private static final class Info_x86 extends IsaPrimitiveInfoAnd {
    Info_x86() {
      super(
          IsaPrimitiveKind.OP,
          "JMP_R16",
          x86.class,
          null
          );
      addArgument("rel", GPR16.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final GPR16 rel = (GPR16) getArgument("rel", args);

      return new x86(
        new JMP_R16(
          rel
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final GPR16 rel;

  public JMP_R16(final GPR16 rel) {
    assert GPR16.INFO.isSupported(rel);
    this.rel = rel;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("JMP %s", rel.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("1111111111000%s", rel.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    pe__.IP.access().store(pe__.IP.access().load().add(rel.access(pe__, vars__).load()));
    vars__.instr_size.access().store(vars__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}