/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class XCHG_R16M16 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "XCHG_R16M16",
          XCHG_R16M16.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("dst", GPR16.INFO);
      addArgument("src", MOFFS.INFO);
      addShortcut(new Info_x86(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final IsaPrimitive src = (IsaPrimitive) getArgument("src", args);

      return new XCHG_R16M16(seg_ovrd, dst, src);
    }
  }
  private static final class Info_x86 extends IsaPrimitiveInfoAnd {
    Info_x86() {
      super(
          IsaPrimitiveKind.OP,
          "XCHG_R16M16",
          x86.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("dst", GPR16.INFO);
      addArgument("src", MOFFS.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final IsaPrimitive src = (IsaPrimitive) getArgument("src", args);

      return new x86(
        new XCHG_R16M16(
          seg_ovrd,
          dst,
          src
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final GPR16 dst;
  public final IsaPrimitive src;

  public XCHG_R16M16(final RSEG16 seg_ovrd, final GPR16 dst, final IsaPrimitive src) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert GPR16.INFO.isSupported(dst);
    assert MOFFS.INFO.isSupported(src);
    this.seg_ovrd = seg_ovrd;
    this.dst = dst;
    this.src = src;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("XCHG %s, %s:%s", dst.syntax(vars__), seg_ovrd.syntax(vars__), src.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("001%s11010000111%s%s%s%s", seg_ovrd.image(vars__), vars__.mod.access().load().toString(), dst.image(vars__), vars__.rm.access().load().toString(), src.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__, vars__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    Location.concat(dst.access(pe__, vars__).bitField(7, 0), dst.access(pe__, vars__).bitField(15, 8)).store(Location.concat(dst.access(pe__, vars__).bitField(7, 0), dst.access(pe__, vars__).bitField(15, 8)).load().xor(Location.concat(pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load())), pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1)))).load()));
    Location.concat(pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1))), pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()))).store(Location.concat(pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1))), pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()))).load().xor(dst.access(pe__, vars__).load()));
    dst.access(pe__, vars__).store(dst.access(pe__, vars__).load().xor(Location.concat(pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1))), pe__.M.access(vars__.base.access().load().add(src.access(pe__, vars__).load()))).load()));
    src.execute(pe__, vars__);
    vars__.instr_size.access().store(vars__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}